//  Xerver Free Web Server
//  Copyright (C) 2002-2007 Omid Rouhani
//
//
//  This program is free software; you can redistribute it and/or
//  modify it under the terms of the GNU General Public License
//  as published by the Free Software Foundation; either version 2
//  of the License, or (at your option) any later version.
//
//  This program is distributed in the hope that it will be useful,
//  but WITHOUT ANY WARRANTY; without even the implied warranty of
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//  GNU General Public License for more details.
//
//  You should have received a copy of the GNU General Public License
//  along with this program; if not, write to the Free Software
//  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
//
//  #############################################################
//  ##  YOU CAN CONTACT THE AUTHOR (OMID ROUHANI) AT:          ##
//  ##  HTTP://WWW.JAVASCRIPT.NU/XERVER/                       ##
//  ##                                                         ##
//  ##  IF YOUR SOFTWARE IS NOT RELEASED UNDER THE             ##
//  ##  GNU GENERAL PUBLIC LICENSE (GPL),                      ##
//  ##  PLEASE DO NOT COPY ANYTHING FROM THIS SOURCE CODE!!!   ##
//  ##                                                         ##
//  ##  FOR FULL LICENSE, PLEASE READ "XERVER LICENSE".        ##
//  #############################################################



package webserver;
import common.*;
import ftp_server.*;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;


import java.io.*;


/**
 *
 * <B>About this class:</B>
 * <BR>
 * This is just a small <CODE>JDialog</CODE> window (which has no tab in the Start-list) with one button.
 * When you press the button the Xerver standard window (used in "maximum mode") will be visible
 * and this window will disappear.
 * <BR>
 * This window was introduced so you shall be able to run Xerver with a window but without the tab in the
 * Start-list.
 *
 * @author <a href="http://www.JavaScript.nu/xerver/" TARGET="_top">Omid Rouhani</a>
 * @version 1.0
 */
final public class MinimizedMode extends JDialog implements ActionListener
{
	private JButton JB_switchMode;
	private ProgramWindow window;

	/**
	 * @param argWin is the <CODE>Window</CODE> which has opened this window.
	 */
	public MinimizedMode(ProgramWindow argWin)
	{
		JB_switchMode=new JButton("Switch mode");
		JB_switchMode.addActionListener(this);
		window=argWin;

		Container CP=getContentPane();
		CP.add(JB_switchMode);
		setTitle("Xerver minimized");
		//setSize(100,80);
		pack();
		addWindowListener(MyWindowListener);
		setVisible(true);
		toBack();
	}


	public void actionPerformed(ActionEvent e)
	{
		if (JB_switchMode==e.getSource())
		{
			goToNormalMode();
		}
	}

	private void goToNormalMode()
	{
			setVisible(false);
			window.setIsRunningButton();
			window.setVisible(true);
			window.toFront();
			dispose();
	}

	private WindowAdapter MyWindowListener = new WindowAdapter()
	{
		public void windowClosing(WindowEvent e)	//Window is closeing
		{
			goToNormalMode();
		}
	};
}